// All public defines,consts

/*================================================================================
[Global defines / Don't change!!!.]
=================================================================================*/
#define MAX_LEVELS 100
#define MAX_HEROES 7
#define MAX_MAPITEMS 500
#define MAX_ITEMS 100
#define MAX_POTIONS 9
#define WORN_TYPES 2
#define	MAX_SKILLS 20
#define MAX_PLUGIN_SKILLS 40 // overall plugins of skill
#define MAX_SKILL_NAME_SIZE 64
#define MAX_SKILL_DESC_SIZE 128
#define MAX_MODEL_LENGTH 32

#define ITEM_NOT_WORN 0
#define ITEM_WORN 1

#define CHAR_ACTIVE 1
#define CHAR_DELETED 0

#define UNLOGGED 0
#define LOGGED 1

#define PTS_HP_MINOR 0
#define PTS_HP_GREATER 1
#define PTS_HP_SUPER 2
#define PTS_MP_MINOR 3
#define PTS_MP_GREATER 4
#define PTS_MP_SUPER 5
#define PTS_RP_MINOR 6
#define PTS_RP_GREATER 7
#define PTS_RP_SUPER 8

#define TASKID_MANAREGEN 6666
#define TASKID_HUDINFO 7666
#define TASKID_FIRSTCONNECT 12444
#define TASKID_POISON 16000
#define TASKID_CROSSBOW 22000

// Arbalet's shoot time
#define SHOOT_TIME 1

// Chars data
#define MAX_CHAR_DATA 16
#define CHAR_ARMOR 0
#define CHAR_DAMAGE 1
#define CHAR_COST 2
#define CHAR_DURABILITY 3
#define CHAR_STR 4
#define CHAR_DEX 5
#define CHAR_BLOCK 6
#define CHAR_LEVEL 7
#define CHAR_GIVEVIT 8
#define CHAR_GIVEENE 9
#define CHAR_TYPE 10
#define CHAR_HASP 11
#define CHAR_PDAMAGE 12
#define CHAR_PDURATION 13
#define CHAR_CROSSBOWDAMAGE 15

// Chars data CHAR_TYPE type values
#define TYPE_GLOVES 0
#define TYPE_BOOTS 1
#define TYPE_BELT 2
#define TYPE_ARMOR 3
#define TYPE_HELM 4
#define TYPE_SHIELD 5
#define TYPE_WEAPON 6
#define TYPE_RING 7
#define TYPE_AMULET 8
#define TYPE_BOLTS 9

#define PRESSED(%0) \
	(((button & (%0)) == (%0)) && ((oldbuttons & (%0)) != (%0)))
	
#define RELEASED(%0) \
	(((button & (%0)) != (%0)) && ((oldbuttons & (%0)) == (%0)))


new const gTableCreateQuery[] =
"						\
    CREATE TABLE IF NOT EXISTS `d2_data`	\
    (						\
        `player_steamid` VARCHAR(25) NOT NULL,	\
        `player_ip` VARCHAR(20) NOT NULL,     	\
        `player_name` VARCHAR(35) NOT NULL,   	\
        `player_data` VARCHAR(6096) NOT NULL, 	\
        `player_data2` VARCHAR(6096) NOT NULL,	\
        `player_data3` VARCHAR(9096) NOT NULL,	\
        PRIMARY KEY(`player_name`,`player_ip`,`player_steamid`),\
        KEY `player_data` (`player_data`),    	\
        KEY `player_data2` (`player_data2`),  	\
        KEY `player_data3` (`player_data3`)   	\
    ) TYPE=MyISAM; 				\
";
/*================================================================================
[End of global defines.]
=================================================================================*/


/*================================================================================
[Editable defines.]
=================================================================================*/
#define DISTANCE_INVENTORY_PLAYER 300.0
#define DISTANCE_NEAR_MONSTER 300.0
#define DISTANCE_E_BUTTON_USE_ENT 80.0
#define MAX_PLAYER_ITEMS 8
#define MAX_INVENTORY_ITEMS 8
#define MAX_PLAYER_POTIONS 10
#define MAX_INVENTORY_POTIONS 10
#define MAX_CHARS 15
/*================================================================================
[End of editable defines.]
=================================================================================*/


/*================================================================================
[Some stocks.]
=================================================================================*/
#define OFFSET_TEAM 114

#define fm_cs_set_user_nobuy(%1) set_pdata_int(%1, 235, get_pdata_int(%1, 235) & ~(1<<0) )
#define fm_set_user_team(%1,%2)	set_pdata_int( %1, OFFSET_TEAM, %2)
#define fm_get_user_team(%1) get_pdata_int( %1, OFFSET_TEAM)

#define TEAM_SELECT_VGUI_MENU_ID 2

#define HIDE_TIMER (1<<4) // hides timer
#define HIDE_RADAR (1<<3) // hides radar,health,armor
#define HIDE_MONEY (1<<5) // hides money
#define HIDE_AMMO (1<<0) // crosshair,ammo,weapon list
#define HIDE_FLASH (1<<1) // flashlight

const m_pPlayer	= 41;
const m_flPrimaryAttack = 46;
const m_flNextSecondaryAttack = 47;
const m_pClientActiveItem = 374;
const m_bitsDamageType = 76;
const m_flWait = 42;
/*================================================================================
[End of some stocks.]
=================================================================================*/

/*================================================================================
[Precache/download files.]
=================================================================================*/
new const LevelUp[] = "d2lod/levelup.wav";

new const g_crossbow_shoot_sound[] = "weapons/xbow_fire1.wav";

new const Custom_Models[MAX_HEROES][] = 
{
	"black_knight",
	"assassin",
	"necromancer",
	"barbarian",
	"black_knight",
	"black_knight",
	"sorceress"
}

new const g_w_mp[] = "models/d2lod/w_mp.mdl";
new const g_w_hp[] = "models/d2lod/w_hp.mdl";
new const g_w_coins[] = "models/d2lod/w_coins.mdl";
new const g_w_item[] = "models/skeleton.mdl";
new const g_w_inventory[] = "models/d2lod/w_inventory.mdl";
new const g_w_charsi[] = "models/d2lod/charsi2.mdl";
new const g_w_akara[] = "models/d2lod/akara.mdl";

new const g_brassknuckles[] = "models/d2lod/v_knuckles.mdl";

// Other custom weapons
new const g_w_crossbow[] = "models/d2lod/crossbow_bolt.mdl";
new const g_v_crossbow[] = "models/d2lod/v_crossbow.mdl";
new const g_p_crossbow[] = "models/d2lod/p_crossbow.mdl";
/*================================================================================
[End of download files.]
=================================================================================*/

/*================================================================================
[Heroe's and their attributes.]
=================================================================================*/
new const Diablo2_Fake_Player_Name[] =  "Diablo II Fake Player CT";

new const HEROES[MAX_HEROES][] = 
{
    "Amazon",
    "Assassin",
    "Necromancer",
    "Barbarian",
    "Paladin",
    "Druid",
    "Sorceress"
} 


/*================================================================================
[End of heroe's attributes.]
=================================================================================*/


/*================================================================================
[Potions and their settings.]
=================================================================================*/
new const Potion_Names[MAX_POTIONS][] = {
	"Minor Health",
	"Greater Health",
	"Super Health",
	"Minor Mana",
	"Greater Mana",
	"Super Mana",
	"Minor rejuvanation",
	"Greater rejuvanation",
	"Super rejuvanation"
}

new const Potion_Cost[MAX_POTIONS] = {
	35,
	65,
	125,
	30,
	50,
	120,
	55,
	80,
	150
}

new const Potion_Multi[MAX_POTIONS] = {
	30,
	80,
	150,
	30,
	80,
	160,
	2,
	1,
	2
}
/*================================================================================
[End of potion settings.]
=================================================================================*/


/*================================================================================
[Editable players stuff.]
=================================================================================*/
new const Float:HEROES_REGAIN_MANA[MAX_HEROES] = { 5.0, 5.0, 4.0, 5.0, 4.0, 4.0, 4.0 }; // Heroes Regenerate mana time

new const HEROES_DEFENCE_DEXTERITY[MAX_HEROES] = { 2, 2, 2, 3, 3, 3, 2 }; //Give x amount of armor of current class, each added dexterity stat point.

new const Float: HEROES_STRENGTH_PERSTAT[MAX_HEROES] = { 0.6, 0.8, 0.5, 0.9, 0.7, 0.6, 0.5 }; //Give x percents of damage of current class, each added stat point.
new const Float: HEROES_DEXTERITY_PERSTAT[MAX_HEROES] = { 1.5, 1.5, 1.5, 1.5, 2.0, 1.5, 1.0 };
// X extra amount of percents to avoid enemy attacks
new const HEROES_VITALITY_PERSTAT[MAX_HEROES] = { 2, 2, 1, 3, 2, 3, 1 }; //Give x amount of health of current class, each added stat point.
new const HEROES_ENERGY_PERSTAT[MAX_HEROES] = { 2, 2, 4, 1, 2, 3, 4 }; //Give x amount of mana of current class, each added stat point.

new const LEVELS[MAX_LEVELS] = { 
100, 200, 300, 400, 700, 900, 1100, 1400, 1700, 2000,
2400, 2900, 3000, 3500, 4200, 5000, 6000, 7500, 9000, 11000,
14000, 17000, 22000, 26000, 31000, 37000, 43000, 49000, 55000, 65000,
70000, 73000, 76000, 80000, 83000, 85000, 90000, 95000, 100000, 110000,
120000, 130000, 140000, 150000, 160000, 170000, 180000, 190000, 200000, 210000,
220000, 240000, 260000, 270000, 280000, 290000, 300000, 320000, 330000, 350000,
360000, 370000, 380000, 390000, 400000, 420000, 430000, 450000, 460000, 480000,
500000, 510000, 520000, 530000, 540000, 550000, 560000, 580000, 600000, 610000,
630000, 650000, 680000, 710000, 740000, 750000, 760000, 780000, 800000, 840000,
880000, 930000, 950000, 1000000, 1100000, 1300000, 1500000, 1700000, 2000000, 2500000
}; // XP Stuff

new const MAX_PLAYER_MONEY[MAX_LEVELS] = { 
50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000,
50000, 50000, 50000, 50000, 50000, 100000, 100000, 100000, 100000, 100000,
100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000,
150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000,
200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000,
300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000,
400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000,
500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000,
700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000,
900000, 900000, 900000, 900000, 1000000, 1000000, 1000000, 1000000, 1000000, 1000000
}; // Money Stuff

new const MAX_PLAYER_MONEY_INV[MAX_LEVELS] = { 
50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000, 50000,
50000, 50000, 50000, 50000, 50000, 100000, 100000, 100000, 100000, 100000,
100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000, 100000,
150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000, 150000,
200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000, 200000,
300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000, 300000,
400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000, 400000,
500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000, 500000,
700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000, 700000,
900000, 900000, 900000, 900000, 1000000, 1000000, 1000000, 1000000, 1000000, 1000000
}; // Inventory Money Stuff
/*================================================================================
[End of edit stuff.]
=================================================================================*/

/*================================================================================
[Others.]
=================================================================================*/
// Non-player consts
new const g_Objective_Ents[][] = {
	"func_bomb_target",
	"info_bomb_target",
	"hostage_entity",
	"monster_scientist",
	"func_hostage_rescue",
	"info_hostage_rescue",
	"info_vip_start",
	"func_vip_safetyzone",
	"func_escapezone",
	"armoury_entity"
}
new const Float:g_flCoordsHUD[][] = 
{
    {0.50, 0.40},
    {0.56, 0.44},
    {0.60, 0.50},
    {0.56, 0.56},
    {0.50, 0.60},
    {0.44, 0.56},
    {0.40, 0.50},
    {0.44, 0.44}
}

enum { USE_OFF, USE_ON, USE_SET, USE_TOGGLE };

new const inventory_dir_name[] = "d2_origins";

new mod_name[32] = "Diablo II: LOD";